#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeSans12pt7b.h>



//#define DEBUG_PRINT //if defined activate print on serial port
//#define DEBUG_PRINT_LCD //if defined activate print on LCD NOT WORKING 
#define DISPLAYS_PRINT //if defined activate print on DISPLAYS

#define OSCOPE_LCD0	   6	
#define OSCOPE_LCD1	   3	
#define OSCOPE_LCD2	   4	
#define OSCOPE_LCD3	   5	
#define OSCOPE_LCD4	   2	
#define OSCOPE_SERCLK  7   
#define OSCOPE_DATA    8
#define testpoint 	   9

#define ENLCD0 A0 
#define ENLCD1 13 
#define ENLCD2 11 
#define ENLCD3 12 
#define ENLCD4 10 

//#define OLED_MOSI  11   //D1
//#define OLED_CLK   10   //D0
//#define OLED_DC    13
//#define OLED_CS    A0
#define OLED_RESET A1
Adafruit_SSD1306 display(OLED_RESET);
//Adafruit_SSD1306 display(OLED_MOSI, OLED_CLK, OLED_DC, OLED_RESET, OLED_CS);

volatile boolean newdatas[5];
volatile int serclk = 0;
volatile unsigned long serdata = 0;
 

volatile unsigned long digit0 = 0;
volatile unsigned long digit1 = 0;
volatile unsigned long digit2 = 0;
volatile unsigned long digit3 = 0;
volatile unsigned long digit4 = 0;
volatile unsigned long datascope;

volatile int i,j;
volatile int current_lcd;
char stringdigit[20];
volatile int serdata_sup0;
volatile int serdata_sup1;
volatile unsigned long pindata;

volatile unsigned long lcddataL[5];
volatile unsigned long lcddataH[5];
volatile unsigned long serdata_sup0L[5];
volatile unsigned long serdata_sup0H[5] ;
volatile unsigned long serdata_sup1L[5];
volatile unsigned long serdata_sup1H[5];


// Install Pin change interrupt for a pin, can be called multiple times

void pciSetup(byte pin)
{
	*digitalPinToPCMSK(pin) |= bit(digitalPinToPCMSKbit(pin));  // enable pin
	PCIFR |= bit(digitalPinToPCICRbit(pin)); // clear any outstanding interrupt
	PCICR |= bit(digitalPinToPCICRbit(pin)); // enable interrupt for the group
}

// Use one Routine to handle each group

ISR(PCINT0_vect) // handle pin change interrupt for D8 to D13 here
{
	digitalWrite(13, digitalRead(8) and digitalRead(9));
}

ISR(PCINT1_vect) // handle pin change interrupt for A0 to A5 here
{
	digitalWrite(13, digitalRead(A0));
}

ISR(PCINT2_vect) // handle pin change interrupt for D0 to D7 here
{
	
	
	if (digitalRead(OSCOPE_LCD0) == 1) current_lcd = 0;
	else if (digitalRead(OSCOPE_LCD1)==1) current_lcd = 1;
	else if (digitalRead(OSCOPE_LCD2) == 1) current_lcd = 2;
	else if (digitalRead(OSCOPE_LCD3) == 1) current_lcd = 3;
	else if (digitalRead(OSCOPE_LCD4) ==1) current_lcd = 4;
	else current_lcd = -1;

	if (current_lcd >= 0) {


		newdatas[current_lcd] = true;
		digitalWrite(testpoint, 0);
		serdata = 0;
		//read data for 32 bits
		for (i = 0; i < 32; i++) {
			//wait clk = 1
			while (digitalRead(OSCOPE_SERCLK) == 0) {
			}


		
			pindata = digitalRead(OSCOPE_DATA);
			digitalWrite(testpoint, pindata);
			serdata = (serdata | ((pindata << i)));
			//		serdata = serdata | (datascope << i);
					//wait clk = 0
			while (digitalRead(OSCOPE_SERCLK) == 1) {
			}

		
		}
		//sup0
		//wait clk = 1
		while (digitalRead(OSCOPE_SERCLK) == 0) {
		}
		digitalWrite(testpoint, 1);
		serdata_sup0 = digitalRead(OSCOPE_DATA);
		//wait clk = 0
		while (digitalRead(OSCOPE_SERCLK) == 1) {
		}
		digitalWrite(testpoint, 0);

		//sup1
		//wait clk = 1
		while (digitalRead(OSCOPE_SERCLK) == 0) {
		}
		digitalWrite(testpoint, 1);
		serdata_sup1 = digitalRead(OSCOPE_DATA);
		//wait clk = 0
		while (digitalRead(OSCOPE_SERCLK) == 1) {
		}
		digitalWrite(testpoint, 0);
		
		//serdata_sup1 selects the h/l datas

		if (serdata_sup1 == 1) {
			lcddataL[current_lcd] = serdata;
			serdata_sup0L[current_lcd] = serdata_sup0;
			serdata_sup1L[current_lcd] = serdata_sup1;
		}
		else
		{
			lcddataH[current_lcd] = serdata;
			serdata_sup0H[current_lcd] = serdata_sup0;
			serdata_sup1H[current_lcd] = serdata_sup1;
		}
		//Serial.print("data interrupt ");
		//Serial.println(serdata);
			//	print_binary(serdata, serdata_sup0, serdata_sup1);

		
			

		//readlcd();

		////wait lcd low


		switch (current_lcd) {


		case (0): while (digitalRead(OSCOPE_LCD0) == 1); break;
		case (1): while (digitalRead(OSCOPE_LCD1) == 1); break;
		case (2): while (digitalRead(OSCOPE_LCD2) == 1); break;
		case (3): while (digitalRead(OSCOPE_LCD3) == 1); break;
		case (4): while (digitalRead(OSCOPE_LCD4) == 1); break;

		}







		digitalWrite(testpoint, 1);
//		Serial.print("dataint lcd ");
//		Serial.println(serdata);
//		Serial.println(current_lcd);
	}
}

void setup() {
	
	pinMode(OSCOPE_SERCLK, INPUT);
	pinMode(OSCOPE_DATA, INPUT);
	pinMode(OSCOPE_LCD0, INPUT);
	pinMode(OSCOPE_LCD1, INPUT);
	pinMode(OSCOPE_LCD2, INPUT);
	pinMode(OSCOPE_LCD3, INPUT);
	pinMode(OSCOPE_LCD4, INPUT);
	pinMode(testpoint, OUTPUT);
	pinMode(ENLCD0, OUTPUT);
	pinMode(ENLCD1, OUTPUT);
	pinMode(ENLCD2, OUTPUT);
	pinMode(ENLCD3, OUTPUT);
	pinMode(ENLCD4, OUTPUT);

	digitalWrite(ENLCD0, 1);
	digitalWrite(ENLCD1, 1);
	digitalWrite(ENLCD2, 1);
	digitalWrite(ENLCD3, 1);
	digitalWrite(ENLCD4, 1);

	display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
	display.clearDisplay();
	display.display();
	display.setTextSize(1);
	display.setTextColor(WHITE);

#ifdef DEBUG_PRINT
	Serial.begin(250000);
#endif

	for (j = 0; j < 5; j++) {
			lcddataL[j] = 0;	
			serdata_sup0L[j] = 0;
			serdata_sup1L[j] = 0;
			lcddataH[j] = 0;
			serdata_sup0H[j] = 0;
			serdata_sup1H[j] = 0;
			newdatas[j] = false;
	}
	//// set pullups, if necessary
	//for (i = 0; i <= 12; i++)
	//	digitalWrite(i, HIGH);  // pinMode( ,INPUT) is default

	//for (i = A0; i <= A5; i++)
	//	digitalWrite(i, HIGH);

	//pinMode(13, OUTPUT);  // LED

						  // enable interrupt for pin...
	pciSetup(OSCOPE_LCD0);
	pciSetup(OSCOPE_LCD1);
	pciSetup(OSCOPE_LCD2);
	pciSetup(OSCOPE_LCD3);
	pciSetup(OSCOPE_LCD4);

//	pciSetup(8);
//	pciSetup(9);
//	pciSetup(A0);
}


void loop() {
	int k;
	while (1) {
		for (k = 0; k < 5; k++)
		{
			if (newdatas[k] == true) {
				newdatas[k] = false;

#ifdef DEBUG_PRINT
				Serial.print("lcd ");
				Serial.println(k);
				print_binary(lcddataL[k], serdata_sup0L[k], serdata_sup1L[k]);
				print_binary(lcddataH[k], serdata_sup0H[k], serdata_sup1H[k]);
#endif

#ifdef DEBUG_PRINT_LCD
				display.print("lcd ");
				display.println(k);
				print_binary(lcddataL[k], serdata_sup0L[k], serdata_sup1L[k]);
				print_binary(lcddataH[k], serdata_sup0H[k], serdata_sup1H[k]);
#endif



				parse(k);
				
			};
		}
		//	parse();
			// Nothing needed
	}
}


void print_binary(unsigned long v, unsigned long sup0, unsigned long sup1)
{
	unsigned long mask = 1, n;
	int k;
	char string[47] = "                                          ";
	//Serial.print(v);
	//Serial.print("  ");
	if (sup1 == 1) {
		string[0] = 'L';
	}
	else
	{
		string[0] = 'H';
	}

	k = 1;
	for (n = 1; n <= 32; n++)
	{
		if ((v & mask) == mask) {
			string[k] = '1';
		}
		else
		{
			string[k] = '0';
		}
		mask = mask << 1;

		k++;
		if ((n % 4) == 0) k++;
	}
	string[46] = '\0';
#ifdef DEBUG_PRINT
	Serial.print(string);
	Serial.print(sup0);
	Serial.println(sup1);
	
#endif

#ifdef DEBUG_PRINT_LCD
	display.print(string);
	display.print(sup0);
	display.println(sup1);

#endif





}



void parse(int lcdtoparse) {


	digit0 = ((lcddataH[lcdtoparse] & 0x154000) >> 14) | ((lcddataL[lcdtoparse] & 0x114000) >> 13);
	digit1 = ((lcddataH[lcdtoparse] & 0x221400) >> 10) | ((lcddataL[lcdtoparse] & 0x21400) >> 9);
	digit2 = ((lcddataH[lcdtoparse] & 0x48000a0) >> 5) | ((lcddataL[lcdtoparse] & 0x8000a0) >> 4);
	digit3 = ((lcddataH[lcdtoparse] & 0x9000000c) >> 2) | ((lcddataL[lcdtoparse] & 0x1000000c));
	digit4 = ((lcddataH[lcdtoparse] & 0x20000050) >> 2) | ((lcddataL[lcdtoparse] & 0x50) | serdata_sup0L[lcdtoparse] | (serdata_sup0H[lcdtoparse] << 1));

	//Serial.print("digits ");
	//Serial.println(digit1);

	if ((digit0 == 83) && (digit1 == 2179) && (digit2 == 2883597)) {
#ifdef DEBUG_PRINT
		Serial.println("OFF");

#endif		
		//		display.setCursor(8, 30);
		stringdigit[i] = 'X';
	}
	else
	{
		i = 0;
		switch (digit4) {


		case (134217751): stringdigit[i++] = '0'; break;
		case (20):stringdigit[i++] = '1'; break;
		case (87):stringdigit[i++] = '2'; break;
		case (85): stringdigit[i++] = '3'; break;
		case (134217812): stringdigit[i++] = '4'; break;
			//	case (): Serial.print("5"); break;
			//	case (): Serial.print("6"); break;
			//	case (): Serial.print("7"); break;
			//	case (): Serial.print("8"); break;
			//	case (): Serial.print("9"); break;

		}

		switch (digit3) {


		case (872415243): stringdigit[i++] = '0'; break;
		case (10): stringdigit[i++] = '1'; break;
		case (335544327): stringdigit[i++] = '2'; break;
		case (268435471): stringdigit[i++] = '3'; break;
		case (536870926): stringdigit[i++] = '4'; break;
		case (805306381): stringdigit[i++] = '5'; break;
		case (872415245): stringdigit[i++] = '6'; break;
		case (536870923): stringdigit[i++] = '7'; break;
		case (872415247): stringdigit[i++] = '8'; break;
		case (805306383): stringdigit[i++] = '9'; break;

		}

		if ((lcddataL[lcdtoparse] & 0x4000000) == 0x4000000) {
			stringdigit[i++] = '.';
		}

		switch (digit2) {


		case (2883597): stringdigit[i++] = '0'; break;
		case (12): stringdigit[i++] = '1'; break;
		case (786439): stringdigit[i++] = '2'; break;
		case (524303): stringdigit[i++] = '3'; break;
		case (2097166): stringdigit[i++] = '4'; break;
		case (2621451): stringdigit[i++] = '5'; break;
		case (2883595): stringdigit[i++] = '6'; break;
		case (2097165): stringdigit[i++] = '7'; break;
		case (2883599): stringdigit[i++] = '8'; break;
		case (2621455): stringdigit[i++] = '9'; break;

		}

		if ((lcddataL[lcdtoparse] & 0x200000) == 0x200000) {
			stringdigit[i++] = '.';
		}

		switch (digit1) {


		case (2445): stringdigit[i++] = '0'; break;
		case (12): stringdigit[i++] = '1'; break;
		case (391): stringdigit[i++] = '2'; break;
		case (271): stringdigit[i++] = '3'; break;
		case (2062): stringdigit[i++] = '4'; break;
		case (2315): stringdigit[i++] = '5'; break;
		case (2443): stringdigit[i++] = '6'; break;
		case (2061): stringdigit[i++] = '7'; break;
		case (2447): stringdigit[i++] = '8'; break;
		case (2319): stringdigit[i++] = '9'; break;;

		}
		if ((lcddataL[lcdtoparse] & 0x40000) == 0x40000) {
			stringdigit[i++] = '.';
		}


		switch (digit0) {


		case (221): stringdigit[i++] = '0'; break;
		case (12): stringdigit[i++] = '1'; break;
		case (199): stringdigit[i++] = '2'; break;
		case (143): stringdigit[i++] = '3'; break;
		case (30): stringdigit[i++] = '4'; break;
		case (155): stringdigit[i++] = '5'; break;
		case (219): stringdigit[i++] = '6'; break;
		case (29): stringdigit[i++] = '7'; break;
		case (223): stringdigit[i++] = '8'; break;
		case (159): stringdigit[i++] = '9'; break;


		}
		stringdigit[i++] = ' ';
		stringdigit[i] = '\0';
	}
#ifdef DEBUG_PRINT
		Serial.print(stringdigit);
		Serial.print(" ");
#endif		
#ifdef DISPLAYS_PRINT
		digitalWrite(ENLCD0, 0);
		digitalWrite(ENLCD1, 0);
		digitalWrite(ENLCD2, 0);
		digitalWrite(ENLCD3, 0);
		digitalWrite(ENLCD4, 0);

		switch (lcdtoparse) {
		case (0): digitalWrite(ENLCD0, 1); break;
		case (1): digitalWrite(ENLCD1, 1); break;
		case (2): digitalWrite(ENLCD2, 1); break;
		case (3): digitalWrite(ENLCD3, 1); break;
		case (4): digitalWrite(ENLCD4, 1); break;
		}


		display.setFont(&FreeSans12pt7b);
		display.fillRect(0, 25, 127, 20, 0);
		display.setCursor(8, 42);
		if (stringdigit[i] == 'X') {
			display.print("OFF");
		}
		else
		{
			if ((lcddataL[lcdtoparse] & 0x8000) == 0x8000) stringdigit[i++] = 'u';
			else if (((lcddataL[lcdtoparse] & 0x2000) == 0x2000) && ((lcddataH[lcdtoparse] & 0x8000) == 0x8000)) stringdigit[i++] = 'm';
			else if ((lcddataH[lcdtoparse] & 0x8000) == 0x8000) stringdigit[i++] = 'n';
			if ((lcddataL[lcdtoparse] & 0x200) == 0x200) stringdigit[i++] = 's';
			else if ((lcddataL[lcdtoparse] & 0x400000) == 0x400000) stringdigit[i++] = 'v';
			if ((lcddataH[lcdtoparse] & 0x400000) == 0x400000) 	stringdigit[i++] = '/';
			stringdigit[i] = '\0';
			display.print(stringdigit);
			if ((lcddataH[lcdtoparse] & 0x1000000) == 0x1000000) display.print("div");
			if ((lcddataL[lcdtoparse] & 0x40000000) == 0x40000000) {
				display.setCursor(8, 62);
				display.setFont();
				display.print("UNCALIBRATED");
			}
			else
			{
				display.fillRect(0, 45, 127, 20, 0);
			}

		}
		display.display();

#endif		




#ifdef DEBUG_PRINT
		if ((lcddataL[lcdtoparse] & 0x40000000) == 0x40000000) {

			Serial.println("UNCALIB");

			
		}

		if ((lcddataL[lcdtoparse] & 0x8000) == 0x8000) {

			Serial.print("u");

			
		}
		else if (((lcddataL[lcdtoparse] & 0x2000) == 0x2000) && ((lcddataH[lcdtoparse] & 0x8000) == 0x8000)) {
		

			Serial.print("m");

		}

		else if ((lcddataH[lcdtoparse] & 0x8000) == 0x8000) {

			Serial.print("n");

		}

		if ((lcddataL[lcdtoparse] & 0x200) == 0x200) {

			Serial.print("S");

		}
		else if ((lcddataL[lcdtoparse] & 0x400000) == 0x400000) {

			Serial.print("V");

		}
		if ((lcddataH[lcdtoparse] & 0x400000) == 0x400000) {

			Serial.print("/");

		}
		if ((lcddataH[lcdtoparse] & 0x1000000) == 0x1000000) {

			Serial.print("div");

		}

		Serial.println();
#endif

	
	//display.display();
}